// 
// IllegalPropertySetDataException.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Jakarta Poi Authors:
//   Drew Varner(Drew.Varner atDomain sc.edu)
//
// Poi.Net Authors:
//   Johannes Roith(johannes at jroith dot de)
//  
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
namespace Poi.Net.HPSF
{
	
	/// <summary> This exception is thrown when there is an illegal value set in a
	///  PropertySet}. For example, a  Variant#VT_BOOL} must
	/// have a value of <code>-1 (true)</code> or <code>0 (false)</code>.
	/// Any other value would trigger this exception. It supports a nested
	/// "reason" throwable, i.e. an exception that caused this one to be
	/// thrown.
	/// 
	/// </summary>
	[Serializable]
	public class IllegalPropertySetDataException:HPSFRuntimeException
	{
		
		public IllegalPropertySetDataException():base()
		{
		}
		
		
		
		public IllegalPropertySetDataException(string msg):base(msg)
		{
		}
		
		
		
		
		public IllegalPropertySetDataException(Exception reason):base(reason)
		{
		}
		
		
		
		
		public IllegalPropertySetDataException(string msg, Exception reason):base(msg, reason)
		{
		}
	}
}