// 
// NoSingleSectionException.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Jakarta Poi Authors:
//   Rainer Klute (klute@rainer-klute.de)
//
// Poi.Net Authors:
//   Johannes Roith(johannes at jroith dot de)
//  
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
namespace Poi.Net.HPSF
{
	
	/// <summary> This exception is thrown if one of the  PropertySet}'s
	/// convenience methods that require a single  Section} is called
	/// and the  PropertySet} does not contain exactly one 
	/// Section}.
	/// 
	/// The constructors of this class are analogous to those of its
	/// superclass and documented there.
	/// 
	/// </summary>
	[Serializable]
	public class NoSingleSectionException:HPSFRuntimeException
	{
		
		public NoSingleSectionException():base()
		{
		}
		
		
		public NoSingleSectionException(string msg):base(msg)
		{
		}
		
		
		
		public NoSingleSectionException(Exception reason):base(reason)
		{
		}
		
		
		
		public NoSingleSectionException(string msg, Exception reason):base(msg, reason)
		{
		}
	}
}