// 
// CHPX.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Jakarta Poi Authors:
//   Ryan Ackley
//
// Poi.Net Authors:
//   Johannes Roith(johannes at jroith dot de)
//  
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;

using Poi.Net.HWPF.UserModel;
using Poi.Net.HWPF.SPRM;

namespace Poi.Net.HWPF.Model
{
	
	/// <summary> Comment me
	/// 
	/// </summary>
	
	public class CHPX:PropertyNode
	{
		virtual public byte[] Grpprl {
			get {
				return ((SprmBuffer) _buf).ToByteArray();
			}			
		}
		virtual public SprmBuffer SprmBuf {
			get {
				return (SprmBuffer) _buf;
			}			
		}
		
		public CHPX(int fcStart, int fcEnd, byte[] grpprl):base(fcStart, fcEnd, new SprmBuffer(grpprl))
		{
		}
		
		public CHPX(int fcStart, int fcEnd, SprmBuffer buf):base(fcStart, fcEnd, buf)
		{
		}
		
		public virtual CharacterProperties GetCharacterProperties(StyleSheet ss, short istd)
		{
			CharacterProperties baseStyle = ss.GetCharacterStyle(istd);
			CharacterProperties props = CharacterSprmUncompressor.UncompressCHP(baseStyle, Grpprl, 0);
			return props;
		}
		
		override public object Clone()
		{
			return null;
		}
		
		override public int CompareTo(object obj)
		{
			return 0;
		}
	}
}