// 
// HWPFFileSystem.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using System.Collections;

namespace Poi.Net.HWPF.Model.IO
{
	
	public class HWPFFileSystem
	{
		
		internal Hashtable _streams = new Hashtable();
		
		public HWPFFileSystem()
		{
			_streams["WordDocument"] = new HWPFOutputStream();
			_streams["1Table"] = new HWPFOutputStream();
			_streams["Data"] = new HWPFOutputStream();
		}
		
		public virtual HWPFOutputStream GetStream(string name)
		{
			
			return (HWPFOutputStream) _streams[name];
		}
	}
}