// 
// HWPFOutputStream.cs
//  
// Copyright 2002-2004  Apache Software Foundation
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using System.IO;

namespace Poi.Net.HWPF.Model.IO
{
	
	public class HWPFOutputStream:MemoryStream
	{
		
		internal int _offset;		

		virtual public int Offset {
			get {
				return _offset;
			}
		}

		public HWPFOutputStream():base()
		{
		}

		public override void Write(byte[] buf, int off, int len)
		{
			base.Write(buf, off, len);
			_offset += len;
		}
		
		public  void WriteByte(int b)
		{
			base.WriteByte((byte) b);
			_offset++;
		}
		
		public override  void WriteByte(byte b)
		{
			WriteByte((int) b);
		}
	}
}