// 
// SEPX.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using Poi.Net.HWPF.SPRM;
using Poi.Net.HWPF.UserModel;

namespace Poi.Net.HWPF.Model
{
	
	public class SEPX:PropertyNode
	{
		virtual public byte[] Grpprl {
			get {
				return SectionSprmCompressor.CompressSectionProperty((SectionProperties) _buf);
			}
			
		}
		virtual public SectionDescriptor SectionDescriptor {
			get {
				return _sed;
			}
			
		}
		virtual public SectionProperties SectionProperties {
			get {
				return (SectionProperties) _buf;
			}
			
		}
		
		internal SectionDescriptor _sed;
		
		public SEPX(SectionDescriptor sed, int start, int end, byte[] grpprl):base(start, end, SectionSprmUncompressor.UncompressSEP(grpprl, 0))
		{
			_sed = sed;
		}
		
		public  override bool Equals(object o)
		{
			SEPX sepx = (SEPX) o;
			if (base.Equals(o))
			{
				return sepx._sed.Equals(_sed);
			}
			return false;
		}
		
		override public object Clone()
		{
			return null;
		}
		
		override public int CompareTo(object obj)
		{
			return 0;
		}
	}
}