// 
// SectionDescriptor.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;

using Poi.Net.Util;
namespace Poi.Net.HWPF.Model
{
	
	public class SectionDescriptor
	{
		virtual public int Fc {
			get {
				return fc;
			}
			
			set {
				this.fc = value;
			}
			
		}
		
		private short fn;
		private int fc;
		private short fnMpr;
		private int fcMpr;
		
		public SectionDescriptor()
		{
		}
		
		public SectionDescriptor(byte[] buf, int offset)
		{
			fn = LittleEndian.GetShort(buf, offset);
			offset += LittleEndian.SHORT_SIZE;
			fc = LittleEndian.GetInt(buf, offset);
			offset += LittleEndian.INT_SIZE;
			fnMpr = LittleEndian.GetShort(buf, offset);
			offset += LittleEndian.SHORT_SIZE;
			fcMpr = LittleEndian.GetInt(buf, offset);
		}
		
		public  override bool Equals(object o)
		{
			SectionDescriptor sed = (SectionDescriptor) o;
			return sed.fn == fn && sed.fnMpr == fnMpr;
		}
		
		public virtual byte[] ToByteArray()
		{
			int offset = 0;
			byte[] buf = new byte[12];
			
			LittleEndian.PutShort(buf, offset, fn);
			offset += LittleEndian.SHORT_SIZE;
			LittleEndian.PutInt(buf, offset, fc);
			offset += LittleEndian.INT_SIZE;
			LittleEndian.PutShort(buf, offset, fnMpr);
			offset += LittleEndian.SHORT_SIZE;
			LittleEndian.PutInt(buf, offset, fcMpr);
			
			return buf;
		}
	}
}