// 
// CachedPropertyNode.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using Poi.Net.HWPF.SPRM;

namespace Poi.Net.HWPF.Model
{
	public class CachedPropertyNode:PropertyNode
	{

		protected internal Object _propCache;

		virtual protected internal object CacheContents {
			get {
				
				return _propCache == null?null:_propCache;
			}
			
		}
		/// <returns> This property's property in compressed form.
		/// </returns>
		virtual public SprmBuffer SprmBuf {
			get {
				return (SprmBuffer) _buf;
			}
			
		}

		public CachedPropertyNode(int start, int end, SprmBuffer buf):base(start, end, buf)
		{
		}
		
		protected internal virtual void FillCache(object reference)
		{
			
			_propCache = reference;
		}
		
		override public object Clone()
		{
			return null;
		}
		
		override public int CompareTo(object obj)
		{
			return 0;
		}
	}

}