// 
// SectionSprmCompressor.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Jakarta Poi Authors:
//   Rainer Klute (klute@rainer-klute.de)
//
// Poi.Net Authors:
//   Johannes Roith(johannes at jroith dot de)
//  
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


//
//
//import java.util.ArrayList;
//import java.util.Arrays;
//
//import Poi.Net.HWPF.Model.Types.SEPAbstractType;
//import Poi.Net.HWPF.UserModel;
//import Poi.Net.Util.LittleEndian;
//
//
//public class SectionSprmCompressor
//{
//  private final static SectionProperties DEFAULT_SEP = new SectionProperties();
//  public SectionSprmCompressor()
//  {
//  }
//  public static byte[] CompressSectionProperty(SectionProperties newSEP,
//                                               SectionProperties oldSEP)
//  {
//    int size = 0;
//    ArrayList sprmList = new ArrayList();
//
//    if (newSEP.getCnsPgn() != DEFAULT_SEP.getCnsPgn())
//    {
//      size += SprmUtils.AddSprm((short)0x3000, newSEP.getCnsPgn(), null, sprmList);
//    }
//    if (newSEP.getIHeadingPgn() != DEFAULT_SEP.getIHeadingPgn())
//    {
//      size += SprmUtils.AddSprm((short)0x3001, newSEP.getIHeadingPgn(), null, sprmList);
//    }
//    if (!Arrays.equals(newSEP.getOlstAnm(), DEFAULT_SEP.getOlstAnm()))
//    {
//      size += SprmUtils.AddSprm((short)0xD202, 0, newSEP.getOlstAnm(), sprmList);
//    }
//    if (newSEP.getFEvenlySpaced() != DEFAULT_SEP.getFEvenlySpaced())
//    {
//      size += SprmUtils.AddSprm((short)0x3005, newSEP.getFEvenlySpaced() ? 1 : 0, null, sprmList);
//    }
//    if (newSEP.getFUnlocked() != DEFAULT_SEP.getFUnlocked())
//    {
//      size += SprmUtils.AddSprm((short)0x3006, newSEP.getFUnlocked() ? 1 :0, null, sprmList);
//    }
//    if (newSEP.getDmBinFirst() != DEFAULT_SEP.getDmBinFirst())
//    {
//      size += SprmUtils.AddSprm((short)0x5007, newSEP.getDmBinFirst(), null, sprmList);
//    }
//    if (newSEP.getDmBinOther() != DEFAULT_SEP.getDmBinOther())
//    {
//      size += SprmUtils.AddSprm((short)0x5008, newSEP.getDmBinOther(), null, sprmList);
//    }
//    if (newSEP.getBkc() != DEFAULT_SEP.getBkc())
//    {
//      size += SprmUtils.AddSprm((short)0x3009, newSEP.getBkc(), null, sprmList);
//    }
//    if (newSEP.getFTitlePage() != DEFAULT_SEP.getFTitlePage())
//    {
//      size += SprmUtils.AddSprm((short)0x300A, newSEP.getFTitlePage() ? 1 : 0, null, sprmList);
//    }
//    if (newSEP.getCcolM1() != DEFAULT_SEP.getCcolM1())
//    {
//      size += SprmUtils.AddSprm((short)0x500B, newSEP.getCcolM1(), null, sprmList);
//    }
//    if (newSEP.getDxaColumns() != DEFAULT_SEP.getDxaColumns())
//    {
//      size += SprmUtils.AddSprm((short)0x900C, newSEP.getDxaColumns(), null, sprmList);
//    }
//    if (newSEP.getFAutoPgn() != DEFAULT_SEP.getFAutoPgn())
//    {
//      size += SprmUtils.AddSprm((short)0x300D, newSEP.getFAutoPgn() ? 1 : 0, null, sprmList);
//    }
//    if (newSEP.getNfcPgn() != DEFAULT_SEP.getNfcPgn())
//    {
//      size += SprmUtils.AddSprm((short)0x300E, newSEP.getNfcPgn(), null, sprmList);
//    }
//    if (newSEP.getDyaPgn() != DEFAULT_SEP.getDyaPgn())
//    {
//      size += SprmUtils.AddSprm((short)0xB00F, newSEP.getDyaPgn(), null, sprmList);
//    }
//    if (newSEP.getDxaPgn() != DEFAULT_SEP.getDxaPgn())
//    {
//      size += SprmUtils.AddSprm((short)0xB010, newSEP.getDxaPgn(), null, sprmList);
//    }
//    if (newSEP.getFPgnReStart != DEFAULT_SEP.getFPgnReStart)
//    {
//      size += SprmUtils.AddSprm((short)0x3011, newSEP.getFPgnReStart ? 1 : 0, null, sprmList);
//    }
//    if (newSEP.getFEndNote() != DEFAULT_SEP.getFEndNote())
//    {
//      size += SprmUtils.AddSprm((short)0x3012, newSEP.getFEndNote() ? 1 : 0, null, sprmList);
//    }
//    if (newSEP.getLnc() != DEFAULT_SEP.getLnc())
//    {
//      size += SprmUtils.AddSprm((short)0x3013, newSEP.getLnc(), null, sprmList);
//    }
//    if (newSEP.getGrpfIhdt() != DEFAULT_SEP.getGrpfIhdt())
//    {
//      size += SprmUtils.AddSprm((short)0x3014, newSEP.getGrpfIhdt(), null, sprmList);
//    }
//    if (newSEP.getNLnnMod() != DEFAULT_SEP.getNLnnMod())
//    {
//      size += SprmUtils.AddSprm((short)0x5015, newSEP.getNLnnMod(), null, sprmList);
//    }
//    if (newSEP.getDxaLnn() != DEFAULT_SEP.getDxaLnn())
//    {
//      size += SprmUtils.AddSprm((short)0x9016, newSEP.getDxaLnn(), null, sprmList);
//    }
//    if (newSEP.getDyaHdrTop() != DEFAULT_SEP.getDyaHdrTop())
//    {
//      size += SprmUtils.AddSprm((short)0xB017, newSEP.getDyaHdrTop(), null, sprmList);
//    }
//    if (newSEP.getDyaHdrBottom() != DEFAULT_SEP.getDyaHdrBottom())
//    {
//      size += SprmUtils.AddSprm((short)0xB018, newSEP.getDyaHdrBottom(), null, sprmList);
//    }
//    if (newSEP.getFLBetween() != DEFAULT_SEP.getFLBetween())
//    {
//      size += SprmUtils.AddSprm((short)0x3019, newSEP.getFLBetween() ? 1 : 0, null, sprmList);
//    }
//    if (newSEP.getVjc() != DEFAULT_SEP.getVjc())
//    {
//      size += SprmUtils.AddSprm((short)0x301A, newSEP.getVjc(), null, sprmList);
//    }
//    if (newSEP.getLnnMin() != DEFAULT_SEP.getLnnMin())
//    {
//      size += SprmUtils.AddSprm((short)0x501B, newSEP.getLnnMin(), null, sprmList);
//    }
//    if (newSEP.getPgnStart != DEFAULT_SEP.getPgnStart)
//    {
//      size += SprmUtils.AddSprm((short)0x501C, newSEP.getPgnStart, null, sprmList);
//    }
//    if (newSEP.getDmOrientPage() != DEFAULT_SEP.getDmOrientPage())
//    {
//      size += SprmUtils.AddSprm((short)0x301D, newSEP.getDmOrientPage(), null, sprmList);
//    }
//    if (newSEP.getXaPage() != DEFAULT_SEP.getXaPage())
//    {
//      size += SprmUtils.AddSprm((short)0xB01F, newSEP.getXaPage(), null, sprmList);
//    }
//    if (newSEP.getYaPage() != DEFAULT_SEP.getYaPage())
//    {
//      size += SprmUtils.AddSprm((short)0xB020, newSEP.getYaPage(), null, sprmList);
//    }
//    if (newSEP.getDxaLeft() != DEFAULT_SEP.getDxaLeft())
//    {
//      size += SprmUtils.AddSprm((short)0xB021, newSEP.getDxaLeft(), null, sprmList);
//    }
//    if (newSEP.getDxaRight() != DEFAULT_SEP.getDxaRight())
//    {
//      size += SprmUtils.AddSprm((short)0xB022, newSEP.getDxaRight(), null, sprmList);
//    }
//    if (newSEP.getDyaTop() != DEFAULT_SEP.getDyaTop())
//    {
//      size += SprmUtils.AddSprm((short)0x9023, newSEP.getDyaTop(), null, sprmList);
//    }
//    if (newSEP.getDyaBottom() != DEFAULT_SEP.getDyaBottom())
//    {
//      size += SprmUtils.AddSprm((short)0x9024, newSEP.getDyaBottom(), null, sprmList);
//    }
//    if (newSEP.getDzaGutter() != DEFAULT_SEP.getDzaGutter())
//    {
//      size += SprmUtils.AddSprm((short)0xB025, newSEP.getDzaGutter(), null, sprmList);
//    }
//    if (newSEP.getDmPaperReq() != DEFAULT_SEP.getDmPaperReq())
//    {
//      size += SprmUtils.AddSprm((short)0x5026, newSEP.getDmPaperReq(), null, sprmList);
//    }
//    if (newSEP.getFPropMark() != DEFAULT_SEP.getFPropMark() ||
//        newSEP.getIbstPropRMark() != DEFAULT_SEP.getIbstPropRMark() ||
//        newSEP.getDttmPropRMark() != DEFAULT_SEP.getDttmPropRMark())
//    {
//      byte[] buf = new byte[7];
//      buf[0] = (byte)(newSEP.getFPropMark() ? 1 : 0);
//      int offset = LittleEndian.BYTE_SIZE;
//      LittleEndian.PutShort(buf, (short)newSEP.getIbstPropRMark());
//      offset += LittleEndian.SHORT_SIZE;
//      LittleEndian.PutInt(buf, newSEP.getDttmPropRMark());
//      size += SprmUtils.AddSprm((short)0xD227, -1, buf, sprmList);
//    }
//    if (!Arrays.equals(newSEP.getBrcTop(), DEFAULT_SEP.getBrcTop()))
//    {
//      size += SprmUtils.AddSprm((short)0x702B, SprmUtils.convertBrcToInt(newSEP.getBrcTop()), null, sprmList);
//    }
//    if (!Arrays.equals(newSEP.getBrcLeft(), DEFAULT_SEP.getBrcLeft()))
//    {
//      size += SprmUtils.AddSprm((short)0x702C, SprmUtils.convertBrcToInt(newSEP.getBrcLeft()), null, sprmList);
//    }
//    if (!Arrays.equals(newSEP.getBrcBottom(), DEFAULT_SEP.getBrcBottom()))
//    {
//      size += SprmUtils.AddSprm((short)0x702D, SprmUtils.convertBrcToInt(newSEP.getBrcBottom()), null, sprmList);
//    }
//    if (!Arrays.equals(newSEP.getBrcRight(), DEFAULT_SEP.getBrcRight()))
//    {
//      size += SprmUtils.AddSprm((short)0x702E, SprmUtils.convertBrcToInt(newSEP.getBrcRight()), null, sprmList);
//    }
//    if (newSEP.getPgbProp() != DEFAULT_SEP.getPgbProp())
//    {
//      size += SprmUtils.AddSprm((short)0x522F, newSEP.getPgbProp(), null, sprmList);
//    }
//    if (newSEP.getDxtCharSpace() != DEFAULT_SEP.getDxtCharSpace())
//    {
//      size += SprmUtils.AddSprm((short)0x7030, newSEP.getDxtCharSpace(), null, sprmList);
//    }
//    if (newSEP.getDyaLinePitch() != DEFAULT_SEP.getDyaLinePitch())
//    {
//      size += SprmUtils.AddSprm((short)0x9031, newSEP.getDyaLinePitch(), null, sprmList);
//    }
//    if (newSEP.getClm() != DEFAULT_SEP.getClm())
//    {
//      size += SprmUtils.AddSprm((short)0x5032, newSEP.getClm(), null, sprmList);
//    }
//    if (newSEP.getWTextFlow() != DEFAULT_SEP.getWTextFlow())
//    {
//      size += SprmUtils.AddSprm((short)0x5033, newSEP.getWTextFlow(), null, sprmList);
//    }
//
//    return SprmUtils.GetGrpprl(sprmList, size);
//  }
//}

using System;
using System.Collections;

using Poi.Net.HWPF.Model;
using Poi.Net.HWPF.UserModel;

using Poi.Net.Util;
namespace Poi.Net.HWPF.SPRM
{
	
	
	public class SectionSprmCompressor
	{
		
		private static readonly SectionProperties DEFAULT_SEP = new SectionProperties();
		public SectionSprmCompressor()
		{
		}
		public static byte[] CompressSectionProperty(SectionProperties newSEP)
		{
			int size = 0;
			ArrayList sprmList = new ArrayList();
			
			if (newSEP.CnsPgn != DEFAULT_SEP.CnsPgn)
			{
				size += SprmUtils.AddSprm((short) 0x3000, newSEP.CnsPgn, null, sprmList);
			}
			if (newSEP.IHeadingPgn != DEFAULT_SEP.IHeadingPgn)
			{
				size += SprmUtils.AddSprm((short) 0x3001, newSEP.IHeadingPgn, null, sprmList);
			}
			if (!ArrayHelper.Equals(newSEP.OlstAnm, DEFAULT_SEP.OlstAnm))
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0xD202), 0, newSEP.OlstAnm, sprmList);
			}
			if (newSEP.FEvenlySpaced != DEFAULT_SEP.FEvenlySpaced)
			{
				size += SprmUtils.AddSprm((short) 0x3005, newSEP.FEvenlySpaced?1:0, null, sprmList);
			}
			if (newSEP.FUnlocked != DEFAULT_SEP.FUnlocked)
			{
				size += SprmUtils.AddSprm((short) 0x3006, newSEP.FUnlocked?1:0, null, sprmList);
			}
			if (newSEP.DmBinFirst != DEFAULT_SEP.DmBinFirst)
			{
				size += SprmUtils.AddSprm((short) 0x5007, newSEP.DmBinFirst, null, sprmList);
			}
			if (newSEP.DmBinOther != DEFAULT_SEP.DmBinOther)
			{
				size += SprmUtils.AddSprm((short) 0x5008, newSEP.DmBinOther, null, sprmList);
			}
			if (newSEP.Bkc != DEFAULT_SEP.Bkc)
			{
				size += SprmUtils.AddSprm((short) 0x3009, newSEP.Bkc, null, sprmList);
			}
			if (newSEP.FTitlePage != DEFAULT_SEP.FTitlePage)
			{
				size += SprmUtils.AddSprm((short) 0x300A, newSEP.FTitlePage?1:0, null, sprmList);
			}
			if (newSEP.CcolM1 != DEFAULT_SEP.CcolM1)
			{
				size += SprmUtils.AddSprm((short) 0x500B, newSEP.CcolM1, null, sprmList);
			}
			if (newSEP.DxaColumns != DEFAULT_SEP.DxaColumns)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0x900C), newSEP.DxaColumns, null, sprmList);
			}
			if (newSEP.FAutoPgn != DEFAULT_SEP.FAutoPgn)
			{
				size += SprmUtils.AddSprm((short) 0x300D, newSEP.FAutoPgn?1:0, null, sprmList);
			}
			if (newSEP.NfcPgn != DEFAULT_SEP.NfcPgn)
			{
				size += SprmUtils.AddSprm((short) 0x300E, newSEP.NfcPgn, null, sprmList);
			}
			if (newSEP.DyaPgn != DEFAULT_SEP.DyaPgn)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0xB00F), newSEP.DyaPgn, null, sprmList);
			}
			if (newSEP.DxaPgn != DEFAULT_SEP.DxaPgn)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0xB010), newSEP.DxaPgn, null, sprmList);
			}
			if (newSEP.FPgnRestart != DEFAULT_SEP.FPgnRestart)
			{
				size += SprmUtils.AddSprm((short) 0x3011, newSEP.FPgnRestart?1:0, null, sprmList);
			}
			if (newSEP.FEndNote != DEFAULT_SEP.FEndNote)
			{
				size += SprmUtils.AddSprm((short) 0x3012, newSEP.FEndNote?1:0, null, sprmList);
			}
			if (newSEP.Lnc != DEFAULT_SEP.Lnc)
			{
				size += SprmUtils.AddSprm((short) 0x3013, newSEP.Lnc, null, sprmList);
			}
			if (newSEP.GrpfIhdt != DEFAULT_SEP.GrpfIhdt)
			{
				size += SprmUtils.AddSprm((short) 0x3014, newSEP.GrpfIhdt, null, sprmList);
			}
			if (newSEP.NLnnMod != DEFAULT_SEP.NLnnMod)
			{
				size += SprmUtils.AddSprm((short) 0x5015, newSEP.NLnnMod, null, sprmList);
			}
			if (newSEP.DxaLnn != DEFAULT_SEP.DxaLnn)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0x9016), newSEP.DxaLnn, null, sprmList);
			}
			if (newSEP.DyaHdrTop != DEFAULT_SEP.DyaHdrTop)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0xB017), newSEP.DyaHdrTop, null, sprmList);
			}
			if (newSEP.DyaHdrBottom != DEFAULT_SEP.DyaHdrBottom)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0xB018), newSEP.DyaHdrBottom, null, sprmList);
			}
			if (newSEP.FLBetween != DEFAULT_SEP.FLBetween)
			{
				size += SprmUtils.AddSprm((short) 0x3019, newSEP.FLBetween?1:0, null, sprmList);
			}
			if (newSEP.Vjc != DEFAULT_SEP.Vjc)
			{
				size += SprmUtils.AddSprm((short) 0x301A, newSEP.Vjc, null, sprmList);
			}
			if (newSEP.LnnMin != DEFAULT_SEP.LnnMin)
			{
				size += SprmUtils.AddSprm((short) 0x501B, newSEP.LnnMin, null, sprmList);
			}
			if (newSEP.PgnStart != DEFAULT_SEP.PgnStart)
			{
				size += SprmUtils.AddSprm((short) 0x501C, newSEP.PgnStart, null, sprmList);
			}
			if (newSEP.DmOrientPage != DEFAULT_SEP.DmOrientPage)
			{
				size += SprmUtils.AddSprm((short) 0x301D, newSEP.DmOrientPage, null, sprmList);
			}
			if (newSEP.XaPage != DEFAULT_SEP.XaPage)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0xB01F), newSEP.XaPage, null, sprmList);
			}
			if (newSEP.YaPage != DEFAULT_SEP.YaPage)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0xB020), newSEP.YaPage, null, sprmList);
			}
			if (newSEP.DxaLeft != DEFAULT_SEP.DxaLeft)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0xB021), newSEP.DxaLeft, null, sprmList);
			}
			if (newSEP.DxaRight != DEFAULT_SEP.DxaRight)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0xB022), newSEP.DxaRight, null, sprmList);
			}
			if (newSEP.DyaTop != DEFAULT_SEP.DyaTop)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0x9023), newSEP.DyaTop, null, sprmList);
			}
			if (newSEP.DyaBottom != DEFAULT_SEP.DyaBottom)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0x9024), newSEP.DyaBottom, null, sprmList);
			}
			if (newSEP.DzaGutter != DEFAULT_SEP.DzaGutter)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0xB025), newSEP.DzaGutter, null, sprmList);
			}
			if (newSEP.DmPaperReq != DEFAULT_SEP.DmPaperReq)
			{
				size += SprmUtils.AddSprm((short) 0x5026, newSEP.DmPaperReq, null, sprmList);
			}
			if (newSEP.FPropMark != DEFAULT_SEP.FPropMark || newSEP.IbstPropRMark != DEFAULT_SEP.IbstPropRMark || !newSEP.DttmPropRMark.Equals(DEFAULT_SEP.DttmPropRMark))
			{
				byte[] buf = new byte[7];
				buf[0] = (byte) (newSEP.FPropMark?1:0);
				int offset = LittleEndian.BYTE_SIZE;
				LittleEndian.PutShort(buf, (short) newSEP.IbstPropRMark);
				offset += LittleEndian.SHORT_SIZE;
				newSEP.DttmPropRMark.Serialize(buf, offset);
				size += SprmUtils.AddSprm(unchecked( (short) 0xD227), - 1, buf, sprmList);
			}
			if (!newSEP.BrcTop.Equals(DEFAULT_SEP.BrcTop))
			{
				size += SprmUtils.AddSprm((short) 0x702B, newSEP.BrcTop.ToInt(), null, sprmList);
			}
			if (!newSEP.BrcLeft.Equals(DEFAULT_SEP.BrcLeft))
			{
				size += SprmUtils.AddSprm((short) 0x702C, newSEP.BrcLeft.ToInt(), null, sprmList);
			}
			if (!newSEP.BrcBottom.Equals(DEFAULT_SEP.BrcBottom))
			{
				size += SprmUtils.AddSprm((short) 0x702D, newSEP.BrcBottom.ToInt(), null, sprmList);
			}
			if (!newSEP.BrcRight.Equals(DEFAULT_SEP.BrcRight))
			{
				size += SprmUtils.AddSprm((short) 0x702E, newSEP.BrcRight.ToInt(), null, sprmList);
			}
			if (newSEP.PgbProp != DEFAULT_SEP.PgbProp)
			{
				size += SprmUtils.AddSprm((short) 0x522F, newSEP.PgbProp, null, sprmList);
			}
			if (newSEP.DxtCharSpace != DEFAULT_SEP.DxtCharSpace)
			{
				size += SprmUtils.AddSprm((short) 0x7030, newSEP.DxtCharSpace, null, sprmList);
			}
			if (newSEP.DyaLinePitch != DEFAULT_SEP.DyaLinePitch)
			{
				size += SprmUtils.AddSprm(unchecked( (short) 0x9031), newSEP.DyaLinePitch, null, sprmList);
			}
			if (newSEP.Clm != DEFAULT_SEP.Clm)
			{
				size += SprmUtils.AddSprm((short) 0x5032, newSEP.Clm, null, sprmList);
			}
			if (newSEP.WTextFlow != DEFAULT_SEP.WTextFlow)
			{
				size += SprmUtils.AddSprm((short) 0x5033, newSEP.WTextFlow, null, sprmList);
			}
			
			return SprmUtils.GetGrpprl(sprmList, size);
		}
	}
}