// 
// SprmIterator.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Jakarta Poi Authors:
//   Rainer Klute (klute@rainer-klute.de)
//
// Poi.Net Authors:
//   Johannes Roith(johannes at jroith dot de)
//  
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
namespace Poi.Net.HWPF.SPRM
{
	
	/// <summary> This class is used to iterate through a list of sprms from a Word 97/2000/XP
	/// document.
	/// </summary>
	/// <author>  Ryan Ackley
	/// </author>
	/// <version>  1.0
	/// </version>
	
	public class SprmIterator
	{
		private byte[] _grpprl;
		internal int _offset;
		
		public SprmIterator(byte[] grpprl, int offset)
		{
			_grpprl = grpprl;
			_offset = offset;
		}
		
		public virtual bool HasNext()
		{
			return _offset < _grpprl.Length;
		}
		
		public virtual SprmOperation Next()
		{
			SprmOperation op = new SprmOperation(_grpprl, _offset);
			_offset += op.Size;
			return op;
		}
	}
}