// 
// ListEntry.cs
//  
// Copyright 2002-2004  Apache Software Foundation
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;

using Poi.Net.HWPF.Model;
using Poi.Net.HWPF.SPRM;

namespace Poi.Net.HWPF.UserModel
{
	
	public class ListEntry:Paragraph
	{
		internal ListLevel _level;
		internal ListFormatOverrideLevel _overrideLevel;
		
		
		public override int Type {
			get { return TYPE_LISTENTRY; }
		}

		internal ListEntry(PAPX papx, Range parent, ListTables tables) : base(papx, parent)
		{
			ListFormatOverride __override = tables.Override(_props.Ilfo);
			_overrideLevel = __override.GetOverrideLevel(_props.Ilvl);
			_level = tables.GetLevel(__override.Lsid, _props.Ilvl);
		}
	}
}