// 
// Section.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using Poi.Net.HWPF.Model;

namespace Poi.Net.HWPF.UserModel
{
	
	public class Section:Range, ICloneable
	{
		virtual public int NumColumns 
		{
			get 
			{
				return _props.CcolM1 + 1;
			}
			
		}
		
		private SectionProperties _props;
		
		public Section(SEPX sepx, Range parent):base(System.Math.Max(parent._start, sepx.Start), System.Math.Min(parent._end, sepx.End), parent)
		{
			_props = sepx.SectionProperties;
		}
		
		public override int Type {
			get { return TYPE_SECTION; }
		}
		
		public override object Clone()
		{
			Section s = (Section) base.Clone();
			s._props = (SectionProperties) _props.Clone();
			return s;
		}
	}
}