// 
// SectionProperties.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using Poi.Net.HWPF.Model;
using Poi.Net.HWPF.Model.Types;

namespace Poi.Net.HWPF.UserModel
{
	
	public class SectionProperties:SEPAbstractType, ICloneable
	{
		public SectionProperties()
		{
			field_20_brcTop = new BorderCode();
			field_21_brcLeft = new BorderCode();
			field_22_brcBottom = new BorderCode();
			field_23_brcRight = new BorderCode();
			field_26_dttmPropRMark = new DateAndTime();
		}
		
		public override object Clone()
		{
			SectionProperties copy = (SectionProperties) base.Clone();
			copy.field_20_brcTop = (BorderCode) field_20_brcTop.Clone();
			copy.field_21_brcLeft = (BorderCode) field_21_brcLeft.Clone();
			copy.field_22_brcBottom = (BorderCode) field_22_brcBottom.Clone();
			copy.field_23_brcRight = (BorderCode) field_23_brcRight.Clone();
			copy.field_26_dttmPropRMark = (DateAndTime) field_26_dttmPropRMark.Clone();
			return copy;
			
		}
		
		public  override bool Equals(object obj)
		{
			System.Reflection.FieldInfo[] fields = typeof(SectionProperties).BaseType.GetFields(System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Public | System.Reflection.BindingFlags.DeclaredOnly);
			
			try
			{
				for (int x = 0; x < fields.Length; x++)
				{
					object obj1 = fields[x].GetValue(this);
					object obj2 = fields[x].GetValue(obj);
					if (obj1 == null && obj2 == null)
					{
						continue;
					}
					if (!obj1.Equals(obj2))
					{
						return false;
					}
				}
				return true;
			}
			catch
			{
				return false;
			}
		}
	}
}