// 
// TableCell.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;

namespace Poi.Net.HWPF.UserModel
{
	
	public class TableCell:Range
	{
		virtual public bool FirstMerged {
			get {
				return _tcd.FFirstMerged;
			}
			
		}
		virtual public bool Merged {
			get {
				return _tcd.FMerged;
			}
			
		}
		virtual public bool Vertical {
			get {
				return _tcd.FVertical;
			}
			
		}
		virtual public bool Backward {
			get {
				return _tcd.FBackward;
			}
			
		}
		virtual public bool RotateFont {
			get {
				return _tcd.FRotateFont;
			}
			
		}
		virtual public bool VerticallyMerged {
			get {
				return _tcd.FVertMerge;
			}
			
		}
		virtual public bool FirstVerticallyMerged {
			get {
				return _tcd.FVertRestart;
			}
			
		}
		virtual public byte VertAlign {
			get {
				return _tcd.VertAlign;
			}
			
		}
		virtual public BorderCode BrcTop {
			get {
				return _tcd.BrcTop;
			}
			
		}
		virtual public BorderCode BrcBottom {
			get {
				return _tcd.BrcBottom;
			}
			
		}
		virtual public BorderCode BrcLeft {
			get {
				return _tcd.BrcLeft;
			}
			
		}
		virtual public BorderCode BrcRight {
			get {
				return _tcd.BrcRight;
			}
			
		}
		virtual public int LeftEdge
		{
			// twips
			
			get
			{
				return _leftEdge;
			}
			
		}
		virtual public int Width
		{
			// twips
			
			get
			{
				return _width;
			}
			
		}
		private int _levelNum;
		private TableCellDescriptor _tcd;
		private int _leftEdge;
		private int _width;
		
		public TableCell(int startIdx, int endIdx, TableRow parent, int levelNum, TableCellDescriptor tcd, int leftEdge, int width):base(startIdx, endIdx, Range.TYPE_PARAGRAPH, parent)
		{
			_tcd = tcd;
			_leftEdge = leftEdge;
			_width = width;
			_levelNum = levelNum;
		}
	}
}