// 
// TableCellDescriptor.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using Poi.Net.HWPF.Model;
using Poi.Net.HWPF.Model.Types;

namespace Poi.Net.HWPF.UserModel
{
	
	public class TableCellDescriptor:TCAbstractType, ICloneable
	{
		public const int SIZE = 20;
		
		public TableCellDescriptor()
		{
			field_3_brcTop = new BorderCode();
			field_4_brcLeft = new BorderCode();
			field_5_brcBottom = new BorderCode();
			field_6_brcRight = new BorderCode();
		}
		
		public override object Clone()
		{	
			TableCellDescriptor tc = (TableCellDescriptor) base.Clone();
			tc.field_3_brcTop = (BorderCode) field_3_brcTop.Clone();
			tc.field_4_brcLeft = (BorderCode) field_4_brcLeft.Clone();
			tc.field_5_brcBottom = (BorderCode) field_5_brcBottom.Clone();
			tc.field_6_brcRight = (BorderCode) field_6_brcRight.Clone();
			return tc;
		}
		
		public static TableCellDescriptor ConvertBytesToTC(byte[] buf, int offset)
		{
			TableCellDescriptor tc = new TableCellDescriptor();
			tc.FillFields(buf, offset);
			return tc;
		}
	}
}