// 
// TableProperties.cs
//  
// Copyright 2002-2004  Apache Software Foundation
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using Poi.Net.HWPF.Model.Types;
namespace Poi.Net.HWPF.UserModel
{
	
	public class TableProperties:TAPAbstractType, ICloneable
	{
		
		public TableProperties()
		{
		}
		public TableProperties(int columns)
		{
			field_7_itcMac = (short) columns;
			field_10_rgshd = new ShadingDescriptor[columns];
			for (int x = 0; x < columns; x++)
			{
				field_10_rgshd[x] = new ShadingDescriptor();
			}
			field_11_brcBottom = new BorderCode();
			field_12_brcTop = new BorderCode();
			field_13_brcLeft = new BorderCode();
			field_14_brcRight = new BorderCode();
			field_15_brcVertical = new BorderCode();
			field_16_brcHorizontal = new BorderCode();
			field_8_rgdxaCenter = new short[columns];
			field_9_rgtc = new TableCellDescriptor[columns];
			for (int x = 0; x < columns; x++)
			{
				field_9_rgtc[x] = new TableCellDescriptor();
			}
		}
		
		public override object Clone()
		{
			TableProperties tap = (TableProperties) base.Clone();
			tap.field_10_rgshd = new ShadingDescriptor[field_10_rgshd.Length];
			for (int x = 0; x < field_10_rgshd.Length; x++)
			{
				tap.field_10_rgshd[x] = (ShadingDescriptor) field_10_rgshd[x].Clone();
			}
			tap.field_11_brcBottom = (BorderCode) field_11_brcBottom.Clone();
			tap.field_12_brcTop = (BorderCode) field_12_brcTop.Clone();
			tap.field_13_brcLeft = (BorderCode) field_13_brcLeft.Clone();
			tap.field_14_brcRight = (BorderCode) field_14_brcRight.Clone();
			tap.field_15_brcVertical = (BorderCode) field_15_brcVertical.Clone();
			tap.field_16_brcHorizontal = (BorderCode) field_16_brcHorizontal.Clone();
			tap.field_8_rgdxaCenter = new short[field_8_rgdxaCenter.Length];
			field_8_rgdxaCenter.CopyTo(tap.field_8_rgdxaCenter, 0);
			tap.field_9_rgtc = new TableCellDescriptor[field_9_rgtc.Length];
			for (int x = 0; x < field_9_rgtc.Length; x++)
			{
				tap.field_9_rgtc[x] = (TableCellDescriptor) field_9_rgtc[x].Clone();
			}
			return tap;
		}
	}
}