// 
// BATManaged.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Jakarta Poi Authors:
//   Marc Johnson (mjohnson at apache dot org)
//
// Poi.Net Authors:
//   Johannes Roith(johannes at jroith dot de)
//  
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
namespace Poi.Net.PoiFS.FileSystem
{
	
	/// <summary> This interface defines behaviors for objects managed by the Block
	/// Allocation Table (BAT).
	/// 
	/// </summary>
	
	public interface BATManaged
	{
		
		/// <summary> Return the number of BigBlock's this instance uses
		/// 
		/// </summary>
		/// <returns> count of BigBlock instances
		/// </returns>
		
		int CountBlocks {		
			get;
		}
		
		/// <summary> Set the start block for this instance
		/// 
		/// </summary>
		/// <param name="index">index into the array of BigBlock instances making
		/// up the the filesystem
		/// </param>
		
		int StartBlock {
			set;
		}
	} 
}