// 
// POIFSWriterListener.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Jakarta Poi Authors:
//   Marc Johnson (mjohnson at apache dot org)
//
// Poi.Net Authors:
//   Johannes Roith(johannes at jroith dot de)
//  
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
namespace Poi.Net.PoiFS.FileSystem
{
	
	/// <summary> Interface POIFSWriterListener
	/// 
	/// </summary>
	
	public interface POIFSWriterListener
	{
		
		/// <summary> Process a POIFSWriterEvent that this listener had registered
		/// for
		/// 
		/// </summary>
		/// <param name="event">the POIFSWriterEvent
		/// </param>
		
		void ProcessPOIFSWriterEvent(POIFSWriterEvent e);
	} 
}