// 
// RootProperty.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Jakarta Poi Authors:
//   Marc Johnson (mjohnson at apache dot org)
//
// Poi.Net Authors:
//   Johannes Roith(johannes at jroith dot de)
//  
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;

using Poi.Net.PoiFS.Common;
using Poi.Net.PoiFS.Storage;

namespace Poi.Net.PoiFS.Properties
{
	
	/// <summary> Root property
	/// 
	/// </summary>
	
	public class RootProperty:DirectoryProperty
	{
		
		/// <summary> Default constructor</summary>
		
		internal RootProperty():base("Root Entry")
		{
			
			// overrides
			NodeColor = _NODE_BLACK;
			PropertyType = PropertyConstants.ROOT_TYPE;
			StartBlock = POIFSConstants.END_OF_CHAIN;
		}
		
		/// <summary> reader constructor
		/// 
		/// </summary>
		/// <param name="index">index number
		/// </param>
		/// <param name="array">byte data
		/// </param>
		/// <param name="offset">offset into byte data
		/// </param>
		
		protected internal RootProperty(int index, byte[] array, int offset):base(index, array, offset)
		{
		}
		
		/// <summary> set size
		/// 
		/// </summary>
		/// <param name="size">size in terms of small blocks
		/// </param>
		
		public override int Size {
			set { base.Size = SmallDocumentBlock.CalcSize(value); }
		}
	} 
}