// 
// HeaderBlockConstants.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Jakarta Poi Authors:
//   Marc Johnson (mjohnson at apache dot org)
//
// Poi.Net Authors:
//   Johannes Roith(johannes at jroith dot de)
//  
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using Poi.Net.PoiFS.Common;
using Poi.Net.Util;

namespace Poi.Net.PoiFS.Storage
{
	
	/// <summary> Constants used in reading/writing the Header block
	/// 
	/// </summary>
	
	public class HeaderBlockConstants {
		
		public readonly static ulong _signature = 16220472316735377360L; //0xE11AB1A1E011CFD0L;
		public readonly static int _bat_array_offset = 0x4c;
		public readonly static int _max_bats_in_header;
		// useful offsets
		public readonly static int _signature_offset = 0;
		public readonly static int _bat_count_offset = 0x2C;
		public readonly static int _property_start_offset = 0x30;
		public readonly static int _sbat_start_offset = 0x3C;
		public readonly static int _sbat_block_count_offset = 0x40;
		public readonly static int _xbat_start_offset = 0x44;
		public readonly static int _xbat_count_offset = 0x48;
		static HeaderBlockConstants ()
		{
			_max_bats_in_header = (POIFSConstants.BIG_BLOCK_SIZE - HeaderBlockConstants._bat_array_offset) / LittleEndian.INT_SIZE;
		}
	}
}