// 
// POIFile.cs
//  
// Copyright 2002-2004  Apache Software Foundation
//
// Jakarta Poi Authors:
//   Rainer Klute (klute@rainer-klute.de)
//
// Poi.Net Authors:
//   Johannes Roith(johannes at jroith dot de)
//  
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using Poi.Net.PoiFS.FileSystem;

namespace Poi.Net.HPSF.Basic
{
	/// <summary> A POI file just for testing.
	/// 
	/// </summary>

	public class POIFile
	{
		virtual public string Name {
			get {
				return name;
			}
			
			set {
				this.name = value;
			}
			
		}
		virtual public POIFSDocumentPath Path {
			get {
				return path;
			}
			
			set {
				this.path = value;
			}
			
		}
		virtual public byte[] Bytes {
			get {
				return bytes;
			}
			
			set {
				this.bytes = value;
			}
			
		}
		
		private string name;
		private POIFSDocumentPath path;
		private byte[] bytes;
	}
}